ACM-ICPC 2018 南京赛区网络预赛-E AC Challenge(状压DP)

版权声明:Dream_dog专属 https://blog.csdn.net/Dog_dream/article/details/82317860

Dlsj is competing in a contest with n (0 < n \le 20)n(0<n≤20) problems. And he knows the answer of all of these problems.

However, he can submit ii-th problem if and only if he has submitted (and passed, of course) s_isi  problems, the p_{i, 1}pi,1 -th, p_{i, 2}pi,2 -th, ......, p_{i, s_i}pi,si -th problem before.(0 < p_{i, j} \le n,0 < j \le s_i,0 < i \le n)(0<pi,j ≤n,0<j≤si ,0<i≤n) After the submit of a problem, he has to wait for one minute, or cooling down time to submit another problem. As soon as the cooling down phase ended, he will submit his solution (and get "Accepted" of course) for the next problem he selected to solve or he will say that the contest is too easy and leave the arena.

"I wonder if I can leave the contest arena when the problems are too easy for me."
"No problem."
—— CCF NOI Problem set

If he submits and passes the ii-th problem on tt-th minute(or the tt-th problem he solve is problem ii), he can get t \times a_i + b_it×ai +bi  points. (|a_i|, |b_i| \le 10^9)(∣ai ∣,∣bi ∣≤109).

Your task is to calculate the maximum number of points he can get in the contest.

Input

The first line of input contains an integer, nn, which is the number of problems.

Then follows nn lines, the ii-th line contains s_i + 3si +3 integers, a_i,b_i,s_i,p_1,p_2,...,p_{s_i}ai ,bi ,si ,p1 ,p2 ,...,psi as described in the description above.

Output

Output one line with one integer, the maximum number of points he can get in the contest.

Hint

In the first sample.

On the first minute, Dlsj submitted the first problem, and get 1 \times 5 + 6 = 111×5+6=11 points.

On the second minute, Dlsj submitted the second problem, and get 2 \times 4 + 5 = 132×4+5=13 points.

On the third minute, Dlsj submitted the third problem, and get 3 \times 3 + 4 = 133×3+4=13 points.

On the forth minute, Dlsj submitted the forth problem, and get 4 \times 2 + 3 = 114×2+3=11 points.

On the fifth minute, Dlsj submitted the fifth problem, and get 5 \times 1 + 2 = 75×1+2=7 points.

So he can get 11+13+13+11+7=5511+13+13+11+7=55 points in total.

In the second sample, you should note that he doesn't have to solve all the problems.

样例输入1复制

5
5 6 0
4 5 1 1
3 4 1 2
2 3 1 3
1 2 1 4

样例输出1复制

55

样例输入2复制

1
-100 0 0

样例输出2复制

0

题解:因为n<=20所以我们可以判断从1到1<<(n+1)的每一个状态每次更新每一个状态的最大值,最后输出最大值就好


#include<cstring>
#include<cstdio>
#include<iostream>
#include<string>
#include<queue>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<stack>
#include<functional>
using namespace std;
#define eb(x) emplace_back(x)
#define pb(x) push_back(x)
#define ps(x) push(x)
#define clr(a,b) memset(a,b,sizeof(a))
#define inf 0x3f3f3f3f3f
#define MAX_N 20000000+5
#define MAX_M 25
typedef long long ll;
const ll INF=10000000000000000LL;
const ll maxn=1<<21;
typedef priority_queue<int,vector<int>,less<int> > pql;
typedef priority_queue<int,vector<int>,greater<int> >pqg;
struct Point
{
    int a,b,s;
    int state;
    void input()
    {
        scanf("%d%d%d",&a,&b,&s);
        for(int i=0; i<s; i++)
        {
            int tm;
            scanf("%d",&tm);
            state|=1<<(tm-1);
        }
    }
} pro[MAX_M];
int n,dp[MAX_N];
int time(int k)
{
    int ans=0;
    while(k)
    {
        if(k&1)
            ans++;
        k>>=1;
    }
    return ans;
}
ll solve()
{
    ll ans=0;
	dp[0] = 0;
    for(int k=1; k<(1<<(n+1)); k++)
    {
        int tt=time(k);
        for(int i=0; i<n; i++)
        {
            if((k&(1<<i)))//判断做起i能否得到这个状态
            {
                ll tmp = k ^ (1 << i);//再判断这个状态的前状态是否满足做这道题的要求
                if((k&pro[i].state)==pro[i].state)
                {
                    dp[k] = max(dp[k], dp[tmp] + tt*pro[i].a + pro[i].b);
                }
            }
            ans=max(ans,(ll)dp[k]);
        }
    }
    return ans;
}
int main()
{
#ifndef ONLINE_JUDGE
    freopen("data.txt","r",stdin);
#endif
    scanf("%d",&n);
    clr(pro,0);
    clr(dp,-inf);
    for(int i=0; i<n; i++)
    {
        pro[i].input();
    }
    printf("%lld\n",solve());
    return 0;
}

猜你喜欢

转载自blog.csdn.net/Dog_dream/article/details/82317860